//+------------------------------------------------------------------+
//|                                               RegressionLine.mq5 |
//|                        Copyright 2011, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//#property indicator_separate_window
#property indicator_chart_window
#include <\\MyClass\ClassLinearRegression.mqh>
#property indicator_buffers 3
#property indicator_plots   3
//--- plot RegLin
#property indicator_label1  "RegLin"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot HighLin
#property indicator_label2  "HighLin"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrBlue
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- plot LowLin
#property indicator_label3  "LowLin"
#property indicator_type3   DRAW_LINE
#property indicator_color3  clrBlue
#property indicator_style3  STYLE_SOLID
#property indicator_width3  1
//--- input parameters
input int      Start=0; // 
input int      End=30; // 
input double   Div=1 ;// 
//--- indicator buffers
double         RegLinBuffer[];
double         HighLinBuffer[];
double         LowLinBuffer[];
bool           First=false ;
CLinReg LinReg ;
//+------------------------------------------------------------------+
int OnInit()
  {
   SetIndexBuffer(0,RegLinBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,HighLinBuffer,INDICATOR_DATA);
   SetIndexBuffer(2,LowLinBuffer,INDICATOR_DATA);
   ArrayInitialize(RegLinBuffer,EMPTY_VALUE) ;
   ArrayInitialize(HighLinBuffer,EMPTY_VALUE) ;
   ArrayInitialize(LowLinBuffer,EMPTY_VALUE) ;
   ArraySetAsSeries(RegLinBuffer,true);
   ArraySetAsSeries(LowLinBuffer,true) ;
   ArraySetAsSeries(HighLinBuffer,true) ;
   return(0);
  }
//===============================================================================
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
      if ( First && Start!=0) return(rates_total) ;
      if (Start >=End) return(rates_total) ;
      ArraySetAsSeries(price,true) ;
      int i ;
      double Inmass[],OutHigMass[],OutLowMass[],OutLinRegMass[];
      ArrayResize (Inmass,End-Start,0) ;
      ArrayResize(OutHigMass,End-Start,0) ;
      ArrayResize(OutLowMass,End-Start,0) ;
      ArrayResize(OutLinRegMass,End-Start,0) ;
      for(i=0; i<End-Start ;i++)
         {
            Inmass[i]=price[i+Start];
         }
      if (LinReg.getLinReg(Inmass,OutLinRegMass)<0)
         {
            Alert("   ");
            return(rates_total) ;
         } ;
      for(i=0; i<End-Start;i++)
         {
            RegLinBuffer[i+Start]=OutLinRegMass[i] ;
         }
      LinReg.getLinRegHitrDisp(Inmass,Div,OutLinRegMass,OutHigMass,OutLowMass) ;
      for(i=0;i<End-Start;i++)
         {
            HighLinBuffer[i+Start]=OutHigMass[i] ;
            LowLinBuffer[i+Start]=OutLowMass[i] ;
         }
      First=true ;
      RegLinBuffer[End]=EMPTY_VALUE ;
      HighLinBuffer[End]=EMPTY_VALUE ;
      LowLinBuffer[End]=EMPTY_VALUE ;
//           ArrayInitialize  
//  0   OnInit()
      for( i=End ;i<rates_total ;i++)
        { 
         RegLinBuffer[i]=EMPTY_VALUE ;
         HighLinBuffer[i]=EMPTY_VALUE ;
         LowLinBuffer[i]=EMPTY_VALUE ;
        }
      for(i=0;i<Start ;i++)
        {
           RegLinBuffer[i]=EMPTY_VALUE ;
           HighLinBuffer[i]=EMPTY_VALUE ;
           LowLinBuffer[i]=EMPTY_VALUE ;
        }
   return(rates_total);
  }
//+------------------------------------------------------------------+
